<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/*
	Game Turn Results (GTR) are separate pages the controller points to for
	further processing -- the same design asp.
*/

class Areas extends CI_Controller
{

	public function __construct()
	{
		parent::__construct();
		$this->load->helper(array('admintools','html','form', 'url'));
		$this->load->library('form_validation');
		$this->load->library('user_agent');
		session_start ();
	}
	
	public function index()
	{
		$data['title'] = "Mozart\'s Music Match";
		$data['affiliate_name'] = AFFILIATE_NAME;
		$data['affiliate_code'] = AFFILIATE_CODE;
		
		$version = $_SESSION['gRev'];
		
		if($version === "rv_5" && $this->agent->is_browser()){
			$this->load->view('templates/header2', $data);
			$this->load->view('areas/index2',$data);
			$this->load->view('templates/footer2',$data);
		}
		if($version === "rv_15" && $this->agent->is_browser()){
			$this->load->view('templates/header2', $data);
			$this->load->view('areas/index',$data);
			$this->load->view('templates/footer2',$data);
		}
		//mobile is a Single Web Page/html5 version; 1 room = 1 page div
		if(($version === "rv_15" || $version === "rv_5") && $this->agent->is_mobile()){
			//$this->load->view('templates/header', $data);
			//$this->load->view('areas/index',$data);
			//$this->load->view('templates/footer',$data);
		}
	}
	
	public function index2()
	{
		$data['title'] = 'The Blood Pit';
		$data['affiliate_name'] = AFFILIATE_NAME;
		$data['affiliate_code'] = AFFILIATE_CODE;
		
		$version = $_SESSION['gRev'];
		
		if($version === "rv_5" && $this->agent->is_browser()){
			$this->load->view('templates/header2', $data);
			$this->load->view('areas/index2',$data);
			$this->load->view('templates/footer2',$data);
		}
		if($version === "rv_15" && $this->agent->is_browser()){
			$this->load->view('templates/header2', $data);
			$this->load->view('areas/index',$data);
			$this->load->view('templates/footer2',$data);
		}
		//mobile is a Single Web Page/html5 version; 1 room = 1 page div
		if(($version === "rv_15" || $version === "rv_5") && $this->agent->is_mobile()){
			//$this->load->view('templates/header', $data);
			//$this->load->view('areas/index',$data);
			//$this->load->view('templates/footer',$data);
		}
	}
}
/* End of file areas.php */
/* Location: ./application/controllers/areas.php */ 	
