<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

if ( ! function_exists('RandomMonster'))
{	
	//Selects a random Monster Type from various locations
	function RandomMonster($where)
	{
		//formerly Arena.asp/PickAreanDefender and CombatTools.asp/loadMonster
		$KeyIn = "";
		//Set FileName
		switch($where)
		{
			case "FOREST":
				//Mnstr-Forest.txt
				$MFile = $_SERVER["DOCUMENT_ROOT"] ."/rawdb/Mnstr-Forest.txt";
			break;
			case "PROVINCE":
				//Mnstr-Province.txt
				$MFile = $_SERVER["DOCUMENT_ROOT"] ."/rawdb/Mnstr-Province.txt";
			break;
			case "ARENA":
				//Mnstr-Arena.txt
				$MFile = $_SERVER["DOCUMENT_ROOT"] ."/rawdb/Mnstr-Arena.txt";
			break;
		}
		
		$handle = @fopen($MFile, "r");
		
		// Randomize
		$MnstrNum = mt_rand(1,33);
		if ($MnstrNum == 0)
		{
			$MnstrNum = 1;
		} //End if
		$_SESSION['MnstrNum'] = intval($MnstrNum);
		
		//Select Random Gender
		$Trash = mt_rand(1,6);
		if ($Trash < 4) {
			$_SESSION['MGender'] = "Male";
		}else{
			$_SESSION['MGender'] = "Female";
		}
		
		if ($handle) {
			//read to a specific line in flat file
			for ($cntr = 1; $cntr < $MnstrNum; $cntr++)
			{
				$KeyIn = "";
				$KeyIn = trim(fgets($handle)); //default line pull is 1024B
				
			} //end Next
			
			fclose($handle);
		}
		$MnstrName = $KeyIn;
		return array($MnstrName,$MnstrNum);
	}
}

if ( ! function_exists('loadMonster'))
{	
	//formerly CombatDuelTools.asp/LoadMatch and CombatTools.asp/loadMonster

	function loadMonster($where,$mnum)
	{
		//Set FileName
		switch($where)
		{
			case "FOREST":
				//Mnstr-Forest.txt
				$MFile = $_SERVER["DOCUMENT_ROOT"] ."/rawdb/MF" . $_SESSION['Level'] . "-" . $mnum . ".txt";
			break;
			case "PROVINCE":
				//Mnstr-Province.txt
				$MFile = $_SERVER["DOCUMENT_ROOT"] ."/rawdb/MP" . $_SESSION['Level'] . "-" . $mnum . ".txt";
			break;
			case "ARENA":
				//Mnstr-Arena.txt
				$MFile = $_SERVER["DOCUMENT_ROOT"] ."/rawdb/MA" . $_SESSION['Level'] . "-" . $mnum . ".txt";
			break;
			case "CHALLENGE":
				//Challenge Duel in the meadow
				$MFile = $_SERVER["DOCUMENT_ROOT"] ."/rawdb/MC" . $_SESSION['Level'] . "-" . $mnum . ".txt";
			break;

		}
				
		$handle = @fopen($MFile, "r");
		$_SESSION['MLevel'] = $_SESSION['Level'];
		if ($handle) {
			for ($cntr = 1; $cntr <= 35; $cntr++)
			{
				$KeyIn = fgets($handle); //default pull is 1024
				//debug
				
				switch ($cntr)
				{
					case 1:
					$_SESSION['MName'] = $KeyIn;
					break;
					case 2:
					$_SESSION['MModStmn'] = $KeyIn;
					break;
					case 3:
					$_SESSION['MModCoor'] = $KeyIn;
					break;
					case 4:
					$_SESSION['MModPsych'] = $KeyIn;
					break;
					case 5:
					$_SESSION['MRenown'] = $KeyIn;
					break;
					case 6:
					$_SESSION['MGold'] = $KeyIn;
					break;
					case 7:
					$_SESSION['MFood'] = $KeyIn;
					break;
					case 8:
					$_SESSION['MArrows'] = $KeyIn;
					break;
					case 9:
					$_SESSION['MGems'] = $KeyIn;
					break;
					case 10:
					$_SESSION['MWS'] = $KeyIn;
					break;
					case 11:
					$_SESSION['MBS'] = $KeyIn;
					break;
					case 12:
					$_SESSION['MPS'] = $KeyIn;
					break;
					case 13:
					$_SESSION['MStyle'] = $KeyIn;
					break;
					case 14:
					$_SESSION['MTotalAP'] = $KeyIn;
					break;
					case 15:
					$_SESSION['MShield'] = $KeyIn;
					break;
					case 16:
					$_SESSION['MSAID'] = $KeyIn;
					break;
					case 17:
					$_SESSION['MSHCost'] = $KeyIn;
					break;
					case 18:
					$_SESSION['MBody'] = $KeyIn;
					break;
					case 19:
					$_SESSION['MBAID'] = $KeyIn;
					break;
					case 20:
					$_SESSION['MBArmCost'] = $KeyIn;
					break;
					case 21:
						$_SESSION['MPrimary'] = $KeyIn;
						$_SESSION['ReadiedMnstrWpn'] = "PRIMARY";
						//readjusted during combat
						break;
					case 22:
					$_SESSION['MPWID'] = $KeyIn;
					break;
					case 23:
					$_SESSION['MPWDam'] = $KeyIn;
					break;
					case 24:
					$_SESSION['MPWDamMod'] = $KeyIn;
					break;
					case 25:
					$_SESSION['MPWCost'] = $KeyIn;
					break;
					case 26:
						$_SESSION['MSecondary'] = $KeyIn;
						break;
					case 27:
					$_SESSION['MSWID'] = $KeyIn;
					break;
					case 28:
					$_SESSION['MSWDam'] = $KeyIn;
					break;
					case 29:
					$_SESSION['MSWDamMod'] = $KeyIn;
					break;
					case 30:
					$_SESSION['MSWCost'] = $KeyIn;
					break;
					case 31:
					$_SESSION['MBackup'] = $KeyIn;
					break;
					case 32:
					$_SESSION['MBWID'] = $KeyIn;
					break;
					case 33:
					$_SESSION['MBWDam'] = $KeyIn;
					break;
					case 34:
					$_SESSION['MBWDamMod'] = $KeyIn;
					break;
					case 35:
					$_SESSION['MBWCost'] = $KeyIn;
					break;
				} //end switch
			} //end Next
			$_SESSION['MScore'] = mt_rand(47,155);	
		} else{
				//echo "Error: unexpected fgets() fail\n";
				@fclose($handle);
		}
		@fclose($handle);
	}
}

if ( ! function_exists('backPackIO'))
{	
	function backPackIO($IO, $Cat, $EID, $Value, $Text)
	{
		//formerly HoardInvntry.asp and Inventory.asp
		//Check IF Player is Member or NOT; then assign file
		$dirPath = $_SERVER['DOCUMENT_ROOT'] . "/custDB/";
		$PID = $_SESSION['PID'];
		$CCP = $_SESSION['CCP'];
		
		if ($_SESSION['Mode'] =="GUEST"){
			$ActiveChar = "NPC-";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-1-BP.xml";
		}else{
			$ActiveChar = "AC-";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-" . $CCP . "-BP.xml";
		}
		
		$xmlData = simplexml_load_file($file1); //consistency of methods
		$MTPockets = $xmlData->count(); //player could buy extra pockets??
		
		//debug:
		//echo $MTPockets." | ".$EID." | ".$Cat." | ".$Value." | ".$Text;
		//$ItemSrc="";
		switch($IO)
		{
			case "IN":
				//Find the First Pocket Node that is Empty
				$ItemCntr = 0; //avoids double entries; insert one item at a time
				for($i=0; $i<=$MTPockets; $i++)
				{
					$KeyIn = $xmlData->Pocket[$i]; //pull up each pocket text node
					//debug
					
					if( $KeyIn=="Empty")
					{
						$xmlData->Pocket[$i]['RawValue'] = $Value;
						$xmlData->Pocket[$i]['EquipNum'] = $EID;
						$xmlData->Pocket[$i]['Category'] = $Cat;
						$xmlData->Pocket[$i] = $Text;
						$xmlData->asXML($file1);
						$ItemCntr++; //increase sentry flag
						break;//for; switch 
					} //End if
				}
				
			break;
			
			case "OUT":
				//Find the First Pocket Node that is Empty
				$item = array("");//extracted item array
				$ItemCntr = 1; //avoids double entries; insert one item at a time
				for($i=0; $i<=$MTPockets; $i++)
				{
					$KeyIn = $xmlData->Pocket[$i]['EquipNum']; //pull up each pocket text node
					
					if($ItemCntr > 1 && $KeyIn==$EID)
					{
						$RawValue = $xmlData->Pocket[$i]['RawValue'];
						$xmlData->Pocket[$i]['RawValue'] = 0;
						$EquipNum = $xmlData->Pocket[$i]['EquipNum'];
						$xmlData->Pocket[$i]['EquipNum'] = 0;
						$Category = $xmlData->Pocket[$i]['Category'];
						$xmlData->Pocket[$i]['Category'] = "";
						$Text = $xmlData->Pocket[$i];
						$xmlData->Pocket[$i] = "Empty";
						$xmlData->asXML($file1);
						$ItemCntr++; //increase sentry flag
						break;//for; switch 
					} //End if
				}
				//debug:
				//print_r($item);
				return array("",$RawValue,$EquipNum,$Category,$Text);
			break;
		}
		
	}
}

if ( ! function_exists('SkillsIO'))
{
	function SkillsIO($IO,$SKName,$SKCat,$Value)
	{
		//Province.asp SkillsIO
		//formerly GTR-Rinn.asp, HoardInvntry.asp and Inventory.asp
		//Check IF Player is Member or NOT; then assign file
		$dirPath = $_SERVER['DOCUMENT_ROOT'] . "/custDB/";
		$PID = $_SESSION['PID'];
		$CCP = $_SESSION['CCP'];
		$SkillValue = 1;
		
		if ($_SESSION['Mode'] =="GUEST"){
			$ActiveChar = "NPC-";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-1-SK.xml";
		}else{
			$ActiveChar = "AC-";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-" . $CCP . "-SK.xml";
		}
		
		$xmlData = simplexml_load_file($file1); //consistency of methods
		$MTPockets = $xmlData->count(); //player could buy extra skills slots??
		
		//debug:
		//echo $MTPockets." | ".$IO." | ".$SKName." | ".$SKCat." | ".$Value;
		//$ItemSrc="";
		switch($IO)
		{
			case "IN":
				//Find the First Skill Node that is Empty or Matches
				$ItemCntr = 1; //avoids double entries; insert one item at a time
				for($i=0; $i<=$MTPockets; $i++)
				{
					$KeyIn = $xmlData->Skill[$i]['Name']; //pull up each pocket text node
					
					if( $KeyIn==$SKName)
					{
						$xmlData->Skill[$i]['Name'] = $SKName;
						if($SKCat =="" || $SKCat == NULL){
							//Do nothing; don't change skill category
						}else{
							$xmlData->Skill[$i]['Category'] = $SKCat;
						}
						$xmlData->Skill[$i] += $Value; //increase skill value
						$xmlData->asXML($file1);
						$ItemCntr++; //increase sentry flag
						break;//for; switch 
					} //End if
					//Add new skill both Skill Name and Skill Category
					if($KeyIn=="None")
					{
						$xmlData->Skill[$i]['Name'] = $SKName;
						$xmlData->Skill[$i]['Category'] = $SKCat;
						$xmlData->Skill[$i] = $Value;
						$xmlData->asXML($file1);
						$ItemCntr++; //increase sentry flag
						break;//for; switch 
					} //End if
				}
				
			break;
			
			//forget skill item array
			case "OUT":
				//Find the First Pocket Node that matches
				
				$ItemCntr = 1; //avoids double entries; insert one item at a time
				for($i=0; $i<=$MTPockets; $i++)
				{
					$KeyIn = $xmlData->Skill[$i]['Name']; //pull up each pocket text node
					
					if($KeyIn==$SKName)
					{
						$xmlData->Skill[$i]['Name'] = "None";
						$xmlData->Skill[$i]['Category'] = "None";
						$xmlData->Skill[$i] = "1";
						$xmlData->asXML($file1);
						$ItemCntr++; //increase sentry flag
						$xmlData->asXML($file1);
						$ItemCntr++; //increase sentry flag
						break;//for; switch 
					} //End if
				}
				
			break;
			
			case "READ":
				//Gets the Skill value
				for($i=0; $i<=$MTPockets; $i++)
				{
					$KeyIn = $xmlData->Skill[$i]['Name']; //pull up each pocket Name attribute
					//retrieve skill rating
					if( $KeyIn==$SKName)
					{
						//$xmlData->Skill[$i]['Name'] = $SKName;
						//$xmlData->Skill[$i]['Category'] = $SKCat;
						$SkillValue = $xmlData->Skill[$i];
						//$ItemCntr++; //increase sentry flag
						break;//for; switch 
					} //End if
					
				}
				
				return $SkillValue;
			break;
		}
	}
}

if ( ! function_exists('QuestsIO'))
{
	function QuestsIO($IO,$obj,$rate,$status,$qid,$qtext)
	{
		//Similar to Province.asp SkillsIO; NEW!
		//formerly HoardInvntry.asp and Inventory.asp
		//Check IF Player is Member or NOT; then assign file
		$dirPath = $_SERVER['DOCUMENT_ROOT'] . "/custDB/";
		$PID = $_SESSION['PID'];
		$CCP = $_SESSION['CCP'];
		
		if ($_SESSION['Mode'] =="GUEST"){
			$ActiveChar = "NPC-";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-1-RQ.xml";
		}else{
			$ActiveChar = "AC-";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-" . $CCP . "-RQ.xml";
		}
		$xmlData = simplexml_load_file($file1); //consistency of methods
		$MTPockets = $xmlData->count(); //player could buy extra skills slots??
		
		//Writes only to 1st record
		$Questxml = simplexml_load_file($file1);
		$MTQuests = $Questxml->count(); //player could buy extra quests??
		//debug:
		//echo $MTPockets." | ".$IO." | ".$obj." | ".$rate." | ".$status." | ".$qid." | ".$qtext;
		//$ItemSrc="";
		//QuestsIO($IO,$obj,$rate,$status,$qid,$qtext)
		switch($IO)
		{
			case "IN":
				//Find the First Pocket Node that is Empty
				$ItemCntr = 1; //avoids double entries; insert one item at a time
				for($i=0; $i<=$MTPockets; $i++)
				{
					$KeyIn = $xmlData->ARQ[$i]; //pull up each pocket text node
					
					if($KeyIn=="None")
					{
						$xmlData->ARQ[$i]['Objective'] = $obj;
						$xmlData->ARQ[$i]['Rating'] = $rate;
						$xmlData->ARQ[$i]['Status'] = $status;
						$xmlData->ARQ[$i]['QID'] = $qid;
						$xmlData->ARQ[$i] = $qtext;
						$xmlData->asXML($file1);
						$ItemCntr++; //increase sentry flag
						break;//for; switch 
					} //End if
				}
				
			break;
			
			//Finished Quests and remove
			case "OUT":
				//Find the First Pocket Node that is Empty
				//$item[];//extracted item array
				$ItemCntr = 1; //avoids double entries; insert one item at a time
				for($i=0; $i<=$MTPockets; $i++)
				{
					$KeyIn = $xmlData->ARQ[$i]['QID']; //pull up each pocket text node
					//TODO: award extra experience points for success.
					if($KeyIn==$EID)
					{
						$xmlData->ARQ[$i]['Objective'] = "0";
						$xmlData->ARQ[$i]['Rating'] = "0";
						$xmlData->ARQ[$i]['Status'] = "0";
						$xmlData->ARQ[$i]['QID'] = "0";
						$xmlData->ARQ[$i] = "None";
						$xmlData->asXML($file1);
						$ItemCntr++; //increase sentry flag
						break;//for; switch 
					} //End if
				}
			break;
		}
	}
}

if ( ! function_exists('BuildRandomChar'))
{
	//=============================================================
	//Random Character Tools - Works 100% in asp July 17, 2001
	//	formerly CGenTools.asp Converted to php 20140601
	//=============================================================
	function BuildRandomChar(){
		$TotalEncounters = 10;
		$CurrentEncounters = 0;
		$Race = 0;
		$Gender = " ";
		$RCmbtStyle = " ";
		$RName  = " ";
		$_SESSION['Click'] = "";
		$PID = $_SESSION['PID'];
		$CCP = 1;
		$KeyNum = 0;
		$Stmn = 0;
		$Coor = 0;
		$Psych = 0;
		$Trash = 0;
		$Cntr = 0;
		$KeyIn = " ";
		$Name = " ";
		$Style = " ";

		$_SESSION['Click'] = "Click";

		//Choose //Randomized Race; Some Races omitted
		//Randomize
		$KeyNum =intval(mt_rand(0,6)) +intval(mt_rand(0,6));

			switch ($KeyNum){
				case 0:
				case 1:
				case 2:
					//Randomize
					$Trash = mt_rand(1,6);
					if ($Trash < 4) {
						$Race = "Folks";
						$RName = "Folks";
					}else{
						$Race = "Goblin";
						$RName = "Goblin";
					}
				break;

				case 3:
				case 4:
				case 5:
					$Race = "Elven";
					$RName = "Elven";
				break;

				case 6:
				case 7:
				case 8:
					//Randomize
					$Trash = mt_rand(1,6);
					if (($Trash = 1) || ($Trash = 2)) {
						$Race = "Dwarf";
						$RName = "Dwarf";
					}
					if (($Trash = 3) || ($Trash = 4)) {
						$Race = "Orc";
						$RName = "Orc";
					}
					if (($Trash = 5) || ($Trash = 6)) {
						$Race = "Troll";
						$RName = "Troll";
					}
				break;

				case 9:
				case 10:
				case 11:
					//Randomize
					$Trash = mt_rand(1,6);
					if (($Trash = 1) || ($Trash = 2)) {
						$Race = "Ogre";
						$RName = "Ogre";
					}
					if (($Trash = 3) || ($Trash = 4)) {
						$Race = "Hobbit";
						$RName = "Hobbit";
					}
					if (($Trash = 5) || ($Trash = 6)) {
						$Race = "Folks";
						$RName = "Folks";
					}
				break;

			default:
				//Randomize
				$Trash = mt_rand(1,6);
				if ($Trash < 4) {
					$Race = "Folks";
					$RName = "Folks";
				}else{
					$Race = "Orc";
					$RName = "Orc";
				}
			break;
		} //End Select

		switch ($Race) {      
			//More Races in Legends: Hobbit, Ogre, Troll, Orc
			//Goblin, Fairy, Bestial, Skaven, Gnome,
			case "Folks":
			case "Goblin":
				$Stmn = 8;
				$Coor = 8;
				$Psych = 8;
			break;

			case "Elven":
			case "Fairy":
				$Stmn = 6;
				$Coor = 10;
				$Psych = 8;
			break;

			case "Dwarf":
			case "Orc":
			case "Troll":
				$Stmn = 10;
				$Coor = 6;
				$Psych = 8;
			break;

			case "Hobbit":
			case "Gnome":
				$Stmn = 7;
				$Coor = 9;
				$Psych = 8;
			break;

			case "Ogre":
			case "Skaven":
			case "Beast":
				$Stmn = 9;
				$Coor = 7;
				$Psych = 8;
			break;

			default:
				$Stmn = 8;
				$Coor = 8;
				$Psych = 8;

		} //End Select

		//Randomly Select Gender 
		$Trash = mt_rand(1,6);

		if ($Trash < 4) {
			$Gender = "Male";
		}else{
			$Gender = "Female";
		}

		$KeyIn = $Gender;
		switch ($KeyIn){
			case "Male":
				//No change from above
			break;
			case "Female":
				$Stmn = $Stmn - 1;

				if ($Race == "Elven") {
					$Psych = $Psych + 1;
					$Coor = $Coor + 2;
				}else{  //It's anything
					$Coor = $Coor + 1;
				}
			break;

		} //End Select

		//Foundation Characteristics with Randomized Additional points
		//Randomize
		$Trash = mt_rand(1,6);
		switch ($Trash){
			case 1:
			case 2:
				$Stmn = $Stmn + 4;
				$Coor = $Coor + 4;
			//$Psych = $Psych
			break;
			case 3:
			case 4:
				$Stmn = $Stmn + 5;
				$Coor = $Coor + 3;
			//$Psych = $Psych;
			break;
			case 5:
			case 6:
				$Stmn = $Stmn + 3;
				$Coor = $Coor + 5;
			//$Psych = $Psych;
			break;

		} //End Select
		
		//Preserve newly generated char into xml files
		//Now load and modify associated XML files with this input
			//See Example 7 - http://www.nusphere.com/kb/phpmanual/ref.simplexml.htm 
			//http://www.php.net/manual/en/simplexml.examples-basic.php
			$dirPath = $_SERVER['DOCUMENT_ROOT'] . "/custDB/";
			$ActiveChar = "NPC-";
			//$fileMR = (string)$dirPath . $ActiveChar . $PID . ".xml";
		
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-1.xml";
			if (file_exists($file1)) {
				$xml = simplexml_load_file($file1);

				$xml->Person[0]['PID']=(string)$PID;
				$xml->Person[0]['RecNum']=(string)$PID . "-1";
				$xml->Person[0]['Status']="NPC";
				$xml->Person[0]['Level']=intval( ( ($Stmn + $Coor + $Psych + 8) - 26) / 6);
				$xml->Person[0]->CID=1;
				$xml->Person[0]->Name="Common Adventurer";
				$xml->Person[0]->Race=(string)$Race;
				$xml->Person[0]->Race['Gender']=(string)$Gender;
				$xml->Person[0]->Stmn=(string)$Stmn;
				$xml->Person[0]->Stmn['ModStmn']=(string)$Stmn;
				$xml->Person[0]->Coor=(string)$Coor;
				$xml->Person[0]->Coor['ModCoor']=intval($Coor-2);
				$xml->Person[0]->Psych=(string)$Psych;
				$xml->Person[0]->Psych['ModPsych']=(string)$Psych;
				$xml->Person[0]->CmbtRec['WS'] = (($Stmn * 2) + (1 * 5));
				$xml->Person[0]->CmbtRec['BS'] = (($Coor * 2) + (1 * 5));
				$xml->Person[0]->CmbtRec['PS'] = (($Coor * 2) + (1 * 5));
				$xml->Person[0]->Shield['SHProtect'] = 0;
				$xml->Person[0]->Body['BArmCoorMod']= -2;
				$xml->asXML($file1);
				
			} else {
				exit('Failed to open NPC files.');
			}
			
			//Set Session variables ($mode,$PID,$CCP,$Race,$Gender,$Stmn,$Coor,$Psych,$Name,$Style)
			$KeyIn = setSessionVars("GUEST",$PID,1,$Race,$Gender,$Stmn,$Coor,$Psych,"Common Adventurer","Normal");
	}//End function
}

if ( ! function_exists('dumpSessionVars'))
{
	//writes Session into charDat-x.xml
	function dumpSessionVars($mode,$PID,$CCP,$Race,$Gender,$Stmn,$Coor,$Psych,$Name,$Style)
	{
		$dirPath = $_SERVER['DOCUMENT_ROOT'] . "/custDB/";
		if ($mode=="GUEST"){
			$ActiveChar = "NPC-";
			//$fileMR = (string)$dirPath . $ActiveChar . $PID . ".xml";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-1.xml";
			$_SESSION['Mode'] = "GUEST";
			$_SESSION['CrntEnc']=0;	//encounter counter
			$_SESSION['TtlEnc']=10;	//limited to 10 combats per login
			$_SESSION['GameLimit'] =10;
			
		}
		if ($mode=="NEW" || $mode=="MEMBER" || $mode=="PATRON"){
			
			$ActiveChar = "AC-";
			$fileMR = (string)$dirPath . $ActiveChar . $PID . ".xml";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-" . $CCP . ".xml";
			$_SESSION['Mode'] = $mode;
			$_SESSION['ModeNum'] = 2; //default Registered Guest
			if ($mode == "PATRON"){
				$_SESSION['ModeNum'] = 3;
			}
			$_SESSION['CrntEnc']=0;	//encounter counter
			$_SESSION['TtlEnc']=100;	//limited to 10 combats per login
			$_SESSION['GameLimit'] =100;
						
		}
		if (file_exists($file1)) {
				$xml = simplexml_load_file($file1);
			} else {
				exit('Failed to open character records. MY_Admin#727');
				//Must be an additional Member character so ...
				//$KeyIn = create_new_characters($PID,$CCP);
			}
		$totalChar = intval($_SESSION['Stmn'] + $_SESSION['Coor'] + $_SESSION['Psych']);
		$_SESSION['Level']=intval(( $totalChar - 26) / 6);
		
		$_SESSION['PID'] = $PID;
		$_SESSION['CCP'] = $CCP; 
		$_SESSION['Authorized'] = TRUE;
		$_SESSION['Flirt'] = "NO";
		
		$xml->Person[0]['Level'] = $_SESSION['Level'];
		$xml->Person[0]['Status'] = (string)$_SESSION['Status']; 
		$xml->Person[0]->Name = (string)$_SESSION['Name']; 
		$xml->Person[0]->Race = (string)$_SESSION['Race']; 
		$xml->Person[0]->Race['Gender'] = (string)$_SESSION['Gender'];
		$xml->Person[0]->Stmn = (string)$_SESSION['Stmn'] ;
		$xml->Person[0]->Stmn['ModStmn'] = (string)$_SESSION['ModStmn'] ;
		$xml->Person[0]->Stmn['StmnTrng'] = (string)$_SESSION['StmnTrng'];
		$xml->Person[0]->Stmn['Fatigue'] = (string)$_SESSION['Fatigue'];
		$xml->Person[0]->Coor = (string)$_SESSION['Coor'] ;
		$xml->Person[0]->Coor['ModCoor'] = $_SESSION['ModCoor']; 
		$xml->Person[0]->Coor['CoorTrng'] = (string) $_SESSION['CoorTrng'];
		$xml->Person[0]->Psych = (string)$_SESSION['Psych'] ;
		$xml->Person[0]->Psych['ModPsych'] = (string)$_SESSION['ModPsych'] ;
		$xml->Person[0]->Psych['PsychTrng'] = $_SESSION['PsychTrng'];
		$xml->Person[0]->Renown =(string)$_SESSION['Renown'] ;
		$xml->Person[0]->Career = (string)$_SESSION['Career'] ;
		$xml->Person[0]->Career['Lost'] =(string)$_SESSION['Lost'] ;
		$xml->Person[0]->Career['Ties']=(string)$_SESSION['Ties'];
		$xml->Person[0]->Career['Wins'] =(string)$_SESSION['Wins'] ;
		
		$xml->Person[0]->Health = (string)$_SESSION['Health'] ;
		$xml->Person[0]->Score = (string) $_SESSION['Score'];
		$xml->Person[0]->Social['Office'] =(string)$_SESSION['Office'] ;
		$xml->Person[0]->Social['Title'] =(string) $_SESSION['Title'];
		$xml->Person[0]->Items['Arrows'] = (string) $_SESSION['Arrows'];
		$xml->Person[0]->Items['Food'] =(string) $_SESSION['Food'];
		$xml->Person[0]->Items['Gold'] = (string) $_SESSION['HGold'];
		//$_SESSION['HGems'] = 0;
		//$_SESSION['Movemnt'] = 8;
		$xml->Person[0]->Loc['MapSQ'] = (string) $_SESSION['MegaSQ'];
		$xml->Person[0]->Loc['CampSite'] = $_SESSION['CampSite'];
		$xml->Person[0]->WSRaw = (string) $_SESSION['WSRaw'];
		$xml->Person[0]->WSRaw['WSCmbt'] = $_SESSION['WSCmbt'] ;
		$xml->Person[0]->WSRaw['WSTrng'] = $_SESSION['WSTrng'] ;
		$xml->Person[0]->BSRaw = (string) $_SESSION['BSRaw'];
		$xml->Person[0]->BSRaw['BSCmbt'] = $_SESSION['BSCmbt'] ;
		$xml->Person[0]->BSRaw['BSTrng'] = $_SESSION['BSTrng'] ;
		$xml->Person[0]->PSRaw = (string) $_SESSION['PSRaw'];
		$xml->Person[0]->PSRaw['PSCmbt'] = $_SESSION['PSCmbt'] ;
		$xml->Person[0]->PSRaw['PSTrng'] = $_SESSION['PSTrng'] ;
		$xml->Person[0]->MSRaw = (string) $_SESSION['MSRaw'];
		$xml->Person[0]->MSRaw['MSCmbt'] = $_SESSION['MSCmbt'] ;
		$xml->Person[0]->MSRaw['MSTrng'] = $_SESSION['MSTrng'] ;
		//$_SESSION['TotalAP'] = intval($xml->Person[0]->Shield['SHProtect']) + intval($xml->Person[0]->Body['BArmProtect']);
		$xml->Person[0]->Shield =(string) $_SESSION['Shield'];
		$xml->Person[0]->Shield['ShCoorMod']=(string) $_SESSION['ShCoorMod'];
		$xml->Person[0]->Shield['SHCost']=(string) $_SESSION['SHCost'];
		$xml->Person[0]->Shield['SHProtect'] =(string) $_SESSION['SHProtect'];
		$xml->Person[0]->Shield['SAID']=(string) $_SESSION['SAID'];
		$xml->Person[0]->Body =(string) $_SESSION['Body'];
		$xml->Person[0]->Body['BArmCoorMod']=(string) $_SESSION['BArmCoorMod'];
		$xml->Person[0]->Body['BArmCost']=(string) $_SESSION['BArmCost'];
		$xml->Person[0]->Body['BArmProtect'] =(string) $_SESSION['BArmProtect'];
		$xml->Person[0]->Body['BAID']=(string) $_SESSION['BAID'];
		$xml->Person[0]->Primary =(string) $_SESSION['WName'];
		
		$xml->Person[0]->Primary['PWCost']=(string) $_SESSION['PWCost'];
		$xml->Person[0]->Primary['PWID']=(string) $_SESSION['PWID'];
		
		$xml->Person[0]->Secondary =(string) $_SESSION['Secondary'];
		$xml->Person[0]->Secondary['SWCost'] = (string) $_SESSION['SWCost'];
		$xml->Person[0]->Secondary['SWID'] = (string) $_SESSION['SWID'];
		$xml->Person[0]->Backup = (string) $_SESSION['Backup'];
		$xml->Person[0]->Backup['BWCost'] = (string) $_SESSION['BWCost'];
		$xml->Person[0]->Backup['BWID'] = (string) $_SESSION['BWID'];
		
		$xml->Person[0]->CmbtRec['WS'] = (string) $_SESSION['WS'];
		$xml->Person[0]->CmbtRec['BS'] = (string) $_SESSION['BS'];
		$xml->Person[0]->CmbtRec['PS'] = (string) $_SESSION['PS'];
		$xml->Person[0]->CmbtRec['MS'] = (string) $_SESSION['MS'];
		$xml->Person[0]->CmbtRec['Style']=(string) $_SESSION['Style'];

		$xml->asXML($file1);
		
		//Update Character Database upon return to usercp
			
	}
}

if ( ! function_exists('setSessionVars'))
{	
	//loads charDat-x.xml
	function setSessionVars($mode,$PID,$CCP,$Race,$Gender,$Stmn,$Coor,$Psych,$Name,$Style)
	{
		$dirPath = $_SERVER['DOCUMENT_ROOT'] . "/custDB/";
		if ($mode=="GUEST"){
			$ActiveChar = "NPC-";
			//$fileMR = (string)$dirPath . $ActiveChar . $PID . ".xml";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-1.xml";
			$_SESSION['Mode'] = "GUEST";
			$_SESSION['CrntEnc']=0;	//encounter counter
			$_SESSION['TtlEnc']=10;	//limited to 10 combats per login
			$_SESSION['GameLimit'] =10;
			
		}
		if ($mode=="NEW" || $mode=="MEMBER" || $mode == "PATRON"){
			
			$ActiveChar = "AC-";
			$fileMR = (string)$dirPath . $ActiveChar . $PID . ".xml";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-" . $CCP . ".xml";
			$_SESSION['Mode'] = $mode;
			$_SESSION['ModeNum'] = 2; //default Registered Guest
			if ($mode == "PATRON"){
				$_SESSION['ModeNum'] = 3;
			}
			$_SESSION['CrntEnc']=0;	//encounter counter
			$_SESSION['TtlEnc']=100;	//limited to 1000 combats per login
			$_SESSION['GameLimit'] =100;
						
		}
		
			if (file_exists($file1)) {
				$xml = simplexml_load_file($file1);
			} else {
				exit('Failed to open character records. MY_Admin#315');
				//Must be an additional Member character so ...
				//$KeyIn = create_new_characters($PID,$CCP);
			}
		//htmlentities((string) $xml->Person[0]->title);
		$_SESSION['PID'] = $PID;
		$_SESSION['CCP'] = $CCP; 
		$_SESSION['Authorized'] = TRUE;
		$_SESSION['Flirt'] = "NO";
		$_SESSION['Status'] = (string) $xml->Person[0]['Status']; 
		$_SESSION['Name'] = (string) $xml->Person[0]->Name; 
		$_SESSION['Race'] = (string) $xml->Person[0]->Race; 
		$_SESSION['Gender'] = (string) $xml->Person[0]->Race['Gender'];
		$_SESSION['Stmn'] = (string) $xml->Person[0]->Stmn;
		$_SESSION['ModStmn'] = (string) $xml->Person[0]->Stmn['ModStmn'];
		$_SESSION['StmnTrng'] = "NO";
		$_SESSION['Fatigue'] = (string) $xml->Person[0]->Stmn;
		$_SESSION['Coor'] = (string) $xml->Person[0]->Coor;
		//$_SESSION['ModCoor'] see below
		$_SESSION['CoorTrng'] = "NO";
		$_SESSION['Psych'] = (string) $xml->Person[0]->Psych;
		$_SESSION['ModPsych'] = (string) $xml->Person[0]->Psych['ModPsych'];
		$_SESSION['PsychTrng'] = "NO";
		$_SESSION['Renown'] =(string) $xml->Person[0]->Renown;
		$_SESSION['Career'] = (string) $xml->Person[0]->Career;
		$_SESSION['Lost'] =(string) $xml->Person[0]->Career['Lost'];
		$_SESSION['Ties'] =(string) $xml->Person[0]->Career['Ties'];
		$_SESSION['Wins'] =(string) $xml->Person[0]->Career['Wins'];
		
		$_SESSION['Health'] = (string) $xml->Person[0]->Health;
		$_SESSION['Score'] = (string) $xml->Person[0]->Score;
		$_SESSION['Office'] =(string) $xml->Person[0]->Social['Office'];
		$_SESSION['Title'] =(string) $xml->Person[0]->Social['Title'];
		$_SESSION['Arrows'] = (string) $xml->Person[0]->Items['Arrows'];
		$_SESSION['Food'] =(string) $xml->Person[0]->Items['Food'];
		$_SESSION['HGold'] = (string) $xml->Person[0]->Items['Gold'];
		$_SESSION['HGems'] = 0;
		$_SESSION['Movemnt'] = 8;
		$_SESSION['MegaSQ'] = (string) $xml->Person[0]->Loc['MapSQ'];
		$_SESSION['CampSite'] = (string) $xml->Person[0]->Loc['CampSite'];
		$_SESSION['WSRaw'] = (string) $xml->Person[0]->WSRaw;
		$_SESSION['WSCmbt'] = "NO";
		$_SESSION['BSRaw'] = (string) $xml->Person[0]->BSRaw;
		$_SESSION['BSCmbt'] = "NO";
		$_SESSION['PSRaw'] = (string) $xml->Person[0]->PSRaw;
		$_SESSION['PSCmbt'] = "NO";
		$_SESSION['MSRaw'] = (string) $xml->Person[0]->MSRaw;
		$_SESSION['MSCmbt'] = "NO";
		$_SESSION['MSTrng'] = "NO";
		$_SESSION['TotalAP'] = intval($xml->Person[0]->Shield['SHProtect']) + intval($xml->Person[0]->Body['BArmProtect']);
		$_SESSION['Shield'] =(string) $xml->Person[0]->Shield;
		$_SESSION['ShCoorMod']=(string)$xml->Person[0]->Shield['ShCoorMod'];
		$_SESSION['SHCost']=(string) $xml->Person[0]->Shield['SHCost'];
		$_SESSION['SHProtect'] =(string) $xml->Person[0]->Shield['SHProtect'];
		$_SESSION['SAID']=(string) $xml->Person[0]->Shield['SAID'];
		$_SESSION['AName'] =(string) $xml->Person[0]->Body;
		$_SESSION['Body'] =(string) $xml->Person[0]->Body;
		$_SESSION['BArmCoorMod']=(string)$xml->Person[0]->Body['BArmCoorMod'];
		$_SESSION['BArmCost']=(string) $xml->Person[0]->Body['BArmCost'];
		$_SESSION['BArmProtect'] =(string) $xml->Person[0]->Body['BArmProtect'];
		$_SESSION['BAID']=(string) $xml->Person[0]->Body['BAID'];
		$_SESSION['WName'] =(string) $xml->Person[0]->Primary;
		$_SESSION['Primary'] =(string) $xml->Person[0]->Primary;
		$_SESSION['PWDam'] = (string) $xml->Person[0]->Primary['PWDam'];
		$_SESSION['PWDamMod'] = (string) $xml->Person[0]->Primary['PWDamMod'];
		$_SESSION['ReadiedWpn'] = (string) $xml->Person[0]->Primary;
		$_SESSION['PWCost']=(string) $xml->Person[0]->Primary['PWCost'];
		$_SESSION['PWID']=(string) $xml->Person[0]->Primary['PWID'];
		$_SESSION['ModCoor'] = intval($_SESSION['Coor'] - $_SESSION['BArmProtect']);
		$_SESSION['Secondary'] =(string) $xml->Person[0]->Secondary;
		$_SESSION['SWDam'] = (string) $xml->Person[0]->Secondary['SWDam'];
		$_SESSION['SWDamMod'] = (string) $xml->Person[0]->Secondary['SWDamMod'];
		$_SESSION['SWCost']=(string) $xml->Person[0]->Secondary['SWCost'];
		$_SESSION['SWID']=(string) $xml->Person[0]->Secondary['SWID'];
		$_SESSION['Backup'] =(string) $xml->Person[0]->Backup;
		$_SESSION['BWDam'] = (string) $xml->Person[0]->Backup['BWDam'];
		$_SESSION['BWDamMod'] = (string) $xml->Person[0]->Backup['BWDamMod'];
		$_SESSION['SWCost']=(string) $xml->Person[0]->Secondary['SWCost'];
		$_SESSION['BWCost']=(string) $xml->Person[0]->Backup['BWCost'];
		$_SESSION['BWID']=(string) $xml->Person[0]->Backup['BWID'];

		$_SESSION['ModCoor'] = $_SESSION['Coor'] + $_SESSION['ShCoorMod'] + $_SESSION['BArmCoorMod'] ; //Note shield and Armor Mods are negative numbers.
		$totalChar = intval($_SESSION['Stmn'] + $_SESSION['Coor'] + $_SESSION['Psych']);
		$_SESSION['Level']=intval(( $totalChar - 26) / 6);
		$_SESSION['WS'] = (string) $xml->Person[0]->CmbtRec['WS'];
		$_SESSION['WSTrng'] = "NO";
		$_SESSION['WSCmbt'] = "NO";
		$_SESSION['BS']=(string) $xml->Person[0]->CmbtRec['BS'];
		$_SESSION['BSTrng'] = "NO";
		$_SESSION['BSCmbt'] = "NO";
		$_SESSION['PS']=(string) $xml->Person[0]->CmbtRec['PS'];
		$_SESSION['PSTrng'] = "NO";
		$_SESSION['PSCmbt'] = "NO";
		$_SESSION['MS']=(string) $xml->Person[0]->CmbtRec['MS'];
		$_SESSION['MSTrng'] = "NO";
		$_SESSION['MSCmbt'] = "NO";
		$_SESSION['Style']=(string) $xml->Person[0]->CmbtRec['Style'];

		session_write_close ();

	} //End function
}

if ( ! function_exists('create_new_characters'))
{
	function create_new_characters($PID,$CID)
	{
		//formerly: processNewMemTools.asp & Frm-MemAddChar.asp; works 100%
		//creates all XML files to use for GUEST or MEMBERS
		//Create Master Record by simply copying raw source to custDB. Update content at Hamlet.
		$dirPath = $_SERVER['DOCUMENT_ROOT'] . "/custDB/"; 
		$ActiveChar = "";
		$ActiveChar = "AC-";
		//Create initial CCP-1 if NEW; otherwise accept any CID# and create
		if($_SESSION['Mode']=="NEW")
		{
			$fileMR = $dirPath . $ActiveChar . $PID . ".xml";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-1.xml";
			
		}
		if($_SESSION['Mode']=="MEMBER")
		{
			$fileMR = $dirPath . $ActiveChar . $PID . ".xml";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-" . $CID . ".xml";
			
		}
		//Do Guest create new characters?
		if($_SESSION['Mode']=="GUEST")
		{
			$ActiveChar = "NPC-";	//Changed for GUEST files
			$CID = 1;				//only permitted 1 char
			$fileMR = $dirPath . $ActiveChar . $PID . ".xml";
			$file1 =(string) $dirPath . $ActiveChar . $PID . "-1.xml";
			
		}
		//Master Record; created once when CID 1 is created
		if($CID==1)
		{
			$srcMR = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000.xml"; 
			copy($srcMR,$fileMR);
		}
		
		//Individual Character Record
		$file1 = $dirPath . $ActiveChar .$PID."-".$CID.".xml";		
		$src1 = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1.xml"; 
		copy($src1,$file1); 
		//BackPack Items
		$fileBP = $dirPath . $ActiveChar . $PID."-".$CID."-BP.xml";	
		$srcBP = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-Items.xml"; 
		copy($srcBP,$fileBP); 
		//Renown Quests
		$fileRQ = $dirPath . $ActiveChar . $PID."-".$CID."-RQ.xml";	
		$srcRQ = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-Quest.xml"; 
		copy($srcRQ,$fileRQ);
		//Skills
		$fileSK = $dirPath . $ActiveChar . $PID."-".$CID."-SK.xml";	
		$srcSK = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-Skills.xml"; 
		copy($srcSK,$fileSK);
		//Bank Horde
		$fileBH = $dirPath . $ActiveChar . $PID ."-".$CID."-HB.xml";	
		$srcBH = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-HoardB.xml"; 
		copy($srcBH,$fileBH);
		//Forest Horde
		$fileFH = $dirPath . $ActiveChar . $PID ."-".$CID."-HF.xml";
		$srcFH = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-HoardF.xml"; 
		copy($srcFH,$fileFH);
		//Province Horde
		$filePH = $dirPath . $ActiveChar . $PID ."-".$CID."-HP.xml";	
		$srcPH = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-HoardP.xml"; 
		copy($srcPH,$filePH);
		//Hamlet Horde; unique OR available to all Characters of this player??
		$fileHH = $dirPath . $ActiveChar . $PID ."-".$CID."-HH.xml";
		$srcHH = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-HoardH.xml"; 
		copy($srcHH,$fileHH);	
		//Magic Spells Known/Active=(limited to IQ/Psych);
		//NEW! for 2014; derived from Skills
		$fileMS = $dirPath . $ActiveChar . $PID ."-".$CID."-MS.xml";	
		$srcMS = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-MagicSpells.xml"; 
		copy($srcMS,$fileMS);
		//Daily Journal=(limited from since last logon; then updated during Campaign)
		//NEW! for 2014; derived from Quests
		$fileDJ = $dirPath . $ActiveChar . $PID ."-".$CID."-DJ.xml";	
		$srcDJ = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000-1-DJounal.xml"; 
		copy($srcDJ,$fileDJ);
		
		//Guest not allowed to issue nor receive Arena Challenge Matches
		if($_SESSION['Mode']=="NEW" || $_SESSION['Mode']=="MEMBER")
		{
			// Arena Challenge Matches: Perhaps these should be stored in mySQL for better management????
			$fileCMI = $dirPath . "CM-".$PID."-".$CID."-ISS.xml";	//Challenge match issued; limited to 10;
			$srcCMI = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/CM-0-1-Issued.xml"; 
			copy($srcCMI,$fileCMI);
			$fileCMR = $dirPath . "CM-".$PID."-".$CID."-RCV.xml";	//Challenge match recieved; unlimited; if over 10 then 1 renown pt each;
			$srcCMR = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/CM-0-1-Rcvd.xml"; 
			copy($srcCMR,$fileCMR);
			//Companions, Followers & Friends; think about leasing/borrowing characters from other players
			//NEW! for 2014; derived from Rogue Prince & Rulers of Renown as master record
			//$fileCF = $dirPath . $ActiveChar . $PID ."-".$CID."-CF.xml";	
			//$srcCF = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000.xml"; 
			//copy($srcCF,$fileCF);
			//Military & Mystical Units (MU) under this char's command
			//NEW! for 2014; derived from Rogue Prince & Rulers of Renown as master record
			//$fileMU = $dirPath . $ActiveChar . $PID ."-".$CID."-MU.xml";
			//$srcMU = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000.xml"; 
			//copy($srcMU,$fileMU);
			//Loyal Locations under this char's rulership; Hamlet is LL[0]
			//NEW! for 2014; derived from Rogue Prince & Rulers of Renown as master record
			//$fileLL = $dirPath . $ActiveChar . $PID ."-".$CID."-LL.xml";
			//$srcLL = $_SERVER['DOCUMENT_ROOT'] . "/rawdb/AC-0000.xml"; 
			//copy($srcLL,$fileLL);		
		}
	}
}

if ( ! function_exists('emailCheck'))
{
	function emailCheck($KeyIn){
		//works 25 Sept 2005
		//Create CheckSum for user's Email -- Works 100% as designated.
		$LetterPos = 1;
		$ChkSum = 0;
		$CheckSum = "0000";
		
		//Player's Email Address
		$x = strlen($KeyIn);
		for ($LocalCntr=0; $LocalCntr<=$x; $LocalCntr++){
			//Prevents Any 2 identical email address
			$LetterPos++;
			$ChkSum = ((ord(substr($KeyIn, $LocalCntr, 1))) * $LetterPos) + intval($ChkSum);
		}
		
		$CheckSum = strval($ChkSum);
		//$this->session->set_userdata('PID', $CheckSum);
		$_SESSION['PID'] = $CheckSum;
		return $CheckSum;
	}
}	

/* End of file adminTools_helper.php */
/* Location: ._lord_hero-quest/helpers */